Index: GraphicsMagick-1.2.5/coders/png.c
===================================================================
--- GraphicsMagick-1.2.5.orig/coders/png.c	2018-01-19 20:08:30.737576639 +0100
+++ GraphicsMagick-1.2.5/coders/png.c	2018-01-19 20:29:20.474317244 +0100
@@ -6638,22 +7008,30 @@ static unsigned int WriteOnePNGImage(Mng
                 }
               if ((!opaque) && (p != (const PixelPacket *) NULL))
                 {
-                  ping_info->valid|=PNG_INFO_tRNS;
-                  ping_info->trans_values.red=ScaleQuantumToShort(p->red)&mask;
-                  ping_info->trans_values.green=ScaleQuantumToShort(p->green)&mask;
-                  ping_info->trans_values.blue=ScaleQuantumToShort(p->blue)&mask;
-                  ping_info->trans_values.gray=
+                  ping_trans_color.red=ScaleQuantumToShort(p->red)&mask;
+                  ping_trans_color.green=ScaleQuantumToShort(p->green)
+                                                &mask;
+                  ping_trans_color.blue=ScaleQuantumToShort(p->blue)
+                                               &mask;
+                  ping_trans_color.gray=
                     (png_uint_16) ScaleQuantumToShort(PixelIntensity(p))&mask;
-                  ping_info->trans_values.index=(unsigned char)
+                  ping_trans_color.index=(unsigned char)
                     (ScaleQuantumToChar(MaxRGB-p->opacity));
+                  ping_valid_trns=1;
+                  (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                    "  Found transparent color: (%d,%d,%d)",
+                    ping_trans_color.red, ping_trans_color.green,
+                    ping_trans_color.blue);
                 }
             }
-          if (ping_info->valid & PNG_INFO_tRNS)
+          if (ping_valid_trns != 0)
             {
               /*
                 Determine if there is one and only one transparent color
                 and if so if it is fully transparent.
               */
+              (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                 "  Determine if there is exactly one transparent color");
               for (y=0; y < (long) image->rows; y++)
                 {
                   p=AcquireImagePixels(image,0,y,image->columns,1,
@@ -6665,7 +7043,7 @@ static unsigned int WriteOnePNGImage(Mng
                     {
                       if (p->opacity != OpaqueOpacity)
                         {
-                          if (!RGBColorMatchExact(ping_info->trans_values,*p))
+                          if (!RGBColorMatchExact(ping_trans_color,*p))
                             {
                               break;  /* Can't use RGB + tRNS for multiple
                                          transparent colors.  */
@@ -6678,7 +7056,7 @@ static unsigned int WriteOnePNGImage(Mng
                         }
                       else
                         {
-                          if (RGBColorMatchExact(ping_info->trans_values,*p))
+                          if (RGBColorMatchExact(ping_trans_color,*p))
                             break; /* Can't use RGB + tRNS when another pixel
                                       having the same RGB samples is
                                       transparent. */
@@ -6689,99 +7067,73 @@ static unsigned int WriteOnePNGImage(Mng
                     break;
                 }
               if (x != 0)
-                ping_info->valid&=(~PNG_INFO_tRNS);
+                {
+                  ping_valid_trns = 0;
+                }
+              else if (logging)
+                {
+                  (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                                        "Single transparent color (%d,%d,%d index=%d)",
+                                        ping_trans_color.red,ping_trans_color.green,
+                                        ping_trans_color.blue,ping_trans_color.index);
+                }
             }
-          if (ping_info->valid & PNG_INFO_tRNS)
+          if (ping_valid_trns != 0)
             {
-              ping_info->color_type &= 0x03;  /* changes 4 or 6 to 0 or 2 */
-              if (image->depth == 8)
+              ping_colortype &= 0x03;  /* changes 4 or 6 to 0 or 2 */
+              if (image_depth == 8)
                 {
-                  ping_info->trans_values.red&=0xff;
-                  ping_info->trans_values.green&=0xff;
-                  ping_info->trans_values.blue&=0xff;
-                  ping_info->trans_values.gray&=0xff;
+                  ping_trans_color.red&=0xff;
+                  ping_trans_color.green&=0xff;
+                  ping_trans_color.blue&=0xff;
+                  ping_trans_color.gray&=0xff;
                 }
             }
         }
-      matte=image->matte;
-      if (ping_info->valid & PNG_INFO_tRNS)
-        image->matte=False;
-      if ((mng_info->optimize || mng_info->IsPalette) &&
-          characteristics.grayscale && (!image->matte || image->depth >= 8))
+      matte=image_matte;
+      if (ping_valid_trns != 0)
+        image_matte=MagickFalse;
+      if (mng_info->IsPalette &&
+          characteristics.grayscale && (!image_matte || image_depth >= 8))
         {
-          if (image->matte)
-            ping_info->color_type=PNG_COLOR_TYPE_GRAY_ALPHA;
+          if (image_matte)
+            ping_colortype=PNG_COLOR_TYPE_GRAY_ALPHA;
           else
             {
-              ping_info->color_type=PNG_COLOR_TYPE_GRAY;
-              if (save_image_depth == 16 && image->depth == 8)
-                ping_info->trans_values.gray*=0x0101;
-            }
-          if (image->depth > QuantumDepth)
-            image->depth=QuantumDepth;
-          if (image->colors == 0 || image->colors-1 > MaxRGB)
-            image->colors=1 << image->depth;
-          if (image->depth > 8)
-            ping_info->bit_depth=16;
+              ping_colortype=PNG_COLOR_TYPE_GRAY;
+              if (save_image_depth == 16 && image_depth == 8)
+                ping_trans_color.gray*=0x0101;
+            }
+          if (image_depth > QuantumDepth)
+            image_depth=QuantumDepth;
+          if (image_colors == 0 || image_colors-1 > MaxRGB)
+            image_colors=1U << image_depth;
+          if (image_depth > 8)
+            ping_bit_depth=16;
           else
             {
-              if (ping_info->color_type == PNG_COLOR_TYPE_PALETTE)
+              if (ping_colortype == PNG_COLOR_TYPE_PALETTE)
                 {
-                  ping_info->bit_depth=1;
-                  while ((int) (1 << ping_info->bit_depth) < (long) image->colors)
-                    ping_info->bit_depth <<= 1;
-                }
-              else if (mng_info->optimize && ping_info->color_type ==
-                       PNG_COLOR_TYPE_GRAY && image->colors < 17 &&
-                       mng_info->IsPalette)
-                {
-
-                  /* Check if grayscale is reducible */
-                  int
-                    i,
-                    depth_4_ok=True,
-                    depth_2_ok=True,
-                    depth_1_ok=True;
-
-                  for (i=0; i < (long) image->colors; i++)
-                    {
-                      unsigned char
-                        intensity;
-
-                      intensity=ScaleQuantumToChar(image->colormap[i].red);
-
-                      if ((intensity & 0x0f) != ((intensity & 0xf0) >> 4))
-                        depth_4_ok=depth_2_ok=depth_1_ok=False;
-                      else if ((intensity & 0x03) != ((intensity & 0x0c) >> 2))
-                        depth_2_ok=depth_1_ok=False;
-                      else if ((intensity & 0x01) != ((intensity & 0x02) >> 1))
-                        depth_1_ok=False;
-                    }
-                  if (depth_1_ok)
-                    ping_info->bit_depth=1;
-                  else if (depth_2_ok)
-                    ping_info->bit_depth=2;
-                  else if (depth_4_ok)
-                    ping_info->bit_depth=4;
+                  ping_bit_depth=1;
+                  while ((int) (1U << ping_bit_depth) <
+                                (long) image_colors)
+                    ping_bit_depth <<= 1;
                 }
             }
         }
       else
         if (mng_info->IsPalette)
           {
-            if (image->depth <= 8)
+            if (image_depth <= 8)
               {
                 unsigned long
                   number_colors;
 
-                number_colors=image->colors;
-                if (matte)
-                  ping_info->valid|=PNG_INFO_tRNS;
+                number_colors=image_colors;
                 /*
                   Set image palette.
                 */
-                ping_info->color_type=PNG_COLOR_TYPE_PALETTE;
-                ping_info->valid|=PNG_INFO_PLTE;
+                ping_colortype=PNG_COLOR_TYPE_PALETTE;
                 if (mng_info->have_write_global_plte && !matte)
                   {
                     png_set_PLTE(ping,ping_info,NULL,0);
@@ -6791,52 +7143,49 @@ static unsigned int WriteOnePNGImage(Mng
                   }
                 else
                   {
-#if defined(PNG_SORT_PALETTE)
-                    unsigned long
-                      save_number_colors;
-
-                    if (mng_info->optimize)
-                      {
-                        save_number_colors=image->colors;
-                        (void) CompressColormapTransFirst(image);
-                        number_colors=image->colors;
-                        image->colors=save_number_colors;
-                      }
-#endif
                     palette=MagickAllocateArray(png_color *,
-                                                number_colors,sizeof(png_color));
+                                                number_colors,
+                                                sizeof(png_color));
                     if (palette == (png_color *) NULL)
-                      ThrowWriterException(ResourceLimitError,
-                                           MemoryAllocationFailed,image);
+                      png_error(ping, "Could not allocate palette");
                     for (i=0; i < (long) number_colors; i++)
                       {
-                        palette[i].red=ScaleQuantumToChar(image->colormap[i].red);
-                        palette[i].green=ScaleQuantumToChar(image->colormap[i].green);
-                        palette[i].blue=ScaleQuantumToChar(image->colormap[i].blue);
+                        palette[i].red=ScaleQuantumToChar
+                                       (image->colormap[i].red);
+                        palette[i].green=ScaleQuantumToChar
+                                       (image->colormap[i].green);
+                        palette[i].blue=ScaleQuantumToChar
+                                       (image->colormap[i].blue);
                       }
                     if (logging)
                       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                            "  Setting up PLTE chunk");
+                           "  Setting up PLTE chunk with %d colors",
+                           (int) number_colors);
                     png_set_PLTE(ping,ping_info,palette,(int) number_colors);
-#if (PNG_LIBPNG_VER > 10008)
                     MagickFreeMemory(palette);
-#endif
                   }
-                ping_info->bit_depth=1;
-                while ((1UL << ping_info->bit_depth) < number_colors)
-                  ping_info->bit_depth <<= 1;
-                ping_info->num_trans=0;
+                ping_bit_depth=1;
+                while ((1U << ping_bit_depth) < number_colors)
+                  ping_bit_depth <<= 1;
+                ping_num_trans=0;
                 if (matte)
                   {
                     int
-                      trans[256];
+                      num_alpha=0,
+                      trans_alpha[256];
 
                     /*
                       Identify which colormap entry is transparent.
                     */
                     assert(number_colors <= 256);
+
+                    (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                     "  Look for transparent colormap entry, number_colors=%d",
+                        (int) number_colors);
+
                     for (i=0; i < (long) number_colors; i++)
-                      trans[i]=256;
+                      trans_alpha[i]=256;
+
                     for (y=0; y < (long) image->rows; y++)
                       {
                         register const PixelPacket
@@ -6856,56 +7205,78 @@ static unsigned int WriteOnePNGImage(Mng
 
                                 index=indexes[x];
                                 assert((unsigned long) index < number_colors);
-                                if (trans[index] != 256)
+                                if (trans_alpha[index] == 256)
                                   {
-                                    if (trans[index] != (png_byte) (255-
-                                                                    ScaleQuantumToChar(p->opacity)))
-                                      {
-                                        ping_info->color_type=PNG_COLOR_TYPE_RGB_ALPHA;
-                                        break;
-                                      }
+                                    (void) LogMagickEvent(CoderEvent,
+                                      GetMagickModule(),
+                                      "  Index=%d is transparent",(int) index);
+                                    trans_alpha[index]=(png_byte) (255-
+                                      ScaleQuantumToChar(p->opacity));
+                                    num_alpha++;
                                   }
-                                trans[index]=(png_byte) (255-
-                                                         ScaleQuantumToChar(p->opacity));
                               }
                             p++;
                           }
-                        if (ping_info->color_type==PNG_COLOR_TYPE_RGB_ALPHA)
-                          {
-                            ping_info->num_trans=0;
-                            ping_info->valid&=(~PNG_INFO_tRNS);
-                            ping_info->valid&=(~PNG_INFO_PLTE);
-                            mng_info->IsPalette=False;
-                            (void) SyncImage(image);
-                            if (logging)
-                              (void) LogMagickEvent(CoderEvent, GetMagickModule(),
-                                                    "    Cannot write image as indexed PNG, writing RGBA.");
-                            break;
-                          }
                       }
-                    if ((ping_info->valid & PNG_INFO_tRNS))
+
+                      (void) LogMagickEvent(CoderEvent, GetMagickModule(),
+                         "  num_alpha = %d",num_alpha);
+                      if (num_alpha == 1)
+                         ping_valid_trns=1;
+                      else
+                      {
+                         ping_colortype=PNG_COLOR_TYPE_RGB_ALPHA;
+                         ping_num_trans=0;
+                         if (ping_bit_depth < 8)
+                            ping_bit_depth=8;
+                         ping_valid_trns = 0;
+                         png_set_invalid(ping, ping_info, PNG_INFO_PLTE);
+                         mng_info->IsPalette=MagickFalse;
+                         image_matte=MagickTrue;
+                         (void) SyncImage(image);
+                         if (logging)
+                           (void) LogMagickEvent(CoderEvent,
+                                                 GetMagickModule(),
+                                                 "    Cannot write image"
+                                                 " as indexed PNG,"
+                                                 " writing RGBA.");
+                       }
+
+                    if (ping_valid_trns != 0)
                       {
                         for (i=0; i < (long) number_colors; i++)
                           {
-                            if (trans[i] == 256)
-                              trans[i]=255;
-                            if (trans[i] != 255)
-                              ping_info->num_trans=(unsigned short) (i+1);
+                            if (trans_alpha[i] == 256)
+                              trans_alpha[i]=255;
+                            if (trans_alpha[i] != 255)
+                              ping_num_trans=(unsigned short) (i+1);
                           }
+                      (void) LogMagickEvent(CoderEvent, GetMagickModule(),
+                         "  ping_num_trans = %d",ping_num_trans);
                       }
-                    if (ping_info->num_trans == 0)
-                      ping_info->valid&=(~PNG_INFO_tRNS);
-                    if (!(ping_info->valid & PNG_INFO_tRNS))
-                      ping_info->num_trans=0;
-                    if (ping_info->num_trans != 0)
+                    if (ping_num_trans == 0)
+                       ping_valid_trns = 0;
+                    else
+                       ping_valid_trns = 1;
+                    if (ping_valid_trns == 0)
+                       ping_num_trans=0;
+
+                    if (ping_valid_trns != 0)
                       {
-                        ping_info->trans=MagickAllocateMemory(unsigned char *,
-                                                              number_colors);
-                        if (ping_info->trans == (unsigned char *) NULL)
-                          ThrowWriterException(ResourceLimitError,
-                                               MemoryAllocationFailed,image);
-                        for (i=0; i < (long) number_colors; i++)
-                          ping_info->trans[i]=(png_byte) trans[i];
+                        ping_trans_alpha=MagickAllocateMemory(
+                          unsigned char *, number_colors);
+                        if (ping_trans_alpha == (unsigned char *) NULL)
+                          png_error(ping, "Could not allocate trans_alpha");
+
+                        for (i=0; i<(int) number_colors; i++)
+                          {
+                            if (trans_alpha[i] == 256)
+                               ping_trans_alpha[i]=255;
+                            else
+                               ping_trans_alpha[i]=(png_byte) trans_alpha[i];
+                           (void) LogMagickEvent(CoderEvent, GetMagickModule(),
+                              "    Alpha[%d]=%d",(int) i, (int) trans_alpha[i]);
+                          }
                       }
                   }
 
@@ -6913,68 +7284,58 @@ static unsigned int WriteOnePNGImage(Mng
                   Identify which colormap entry is the background color.
                 */
                 for (i=0; i < (long) Max(number_colors-1,1); i++)
-                  if (RGBColorMatchExact(ping_info->background,image->colormap[i]))
+                  if (RGBColorMatchExact(ping_background,
+                                         image->colormap[i]))
                     break;
-                ping_info->background.index=(png_uint_16) i;
+                ping_background.index=(png_uint_16) i;
               }
           }
         else
           {
-            if (image->depth < 8)
-              image->depth=8;
-            if ((save_image_depth == 16) && (image->depth == 8))
+            if (image_depth < 8)
+              image_depth=8;
+            if ((save_image_depth == 16) && (image_depth == 8))
               {
-                ping_info->trans_values.red*=0x0101;
-                ping_info->trans_values.green*=0x0101;
-                ping_info->trans_values.blue*=0x0101;
-                ping_info->trans_values.gray*=0x0101;
+                ping_trans_color.red*=0x0101;
+                ping_trans_color.green*=0x0101;
+                ping_trans_color.blue*=0x0101;
+                ping_trans_color.gray*=0x0101;
               }
           }
 
       /*
-        Adjust background and transparency samples in sub-8-bit grayscale files.
+        Adjust background and transparency samples in sub-8-bit
+        grayscale files.
       */
-      if (ping_info->bit_depth < 8 && ping_info->color_type ==
+      if (ping_bit_depth < 8 && ping_colortype ==
           PNG_COLOR_TYPE_GRAY)
         {
           png_uint_16
             maxval;
 
-          png_color_16
-            background;
-
-          maxval=(1 << ping_info->bit_depth)-1;
-
-
-          background.gray=(png_uint_16)
-            (maxval*(PixelIntensity(&image->background_color))/MaxRGB);
+          maxval=(1U << ping_bit_depth)-1;
 
-          if (logging)
-            (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                  "  Setting up bKGD chunk");
-          png_set_bKGD(ping,ping_info,&background);
-
-          ping_info->trans_values.gray=(png_uint_16)(maxval*
-                                                     ping_info->trans_values.gray/MaxRGB);
+          ping_trans_color.gray=(png_uint_16)(maxval*
+                                ping_trans_color.gray/
+                                MaxRGB);
         }
     }
+
   if (logging)
     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                           "    PNG color type: %s (%d)",
-                          PngColorTypeToString(ping_info->color_type),
-                          ping_info->color_type);
+                          PngColorTypeToString(ping_colortype),
+                          ping_colortype);
   /*
     Initialize compression level and filtering.
   */
   if (logging)
     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                           "  Setting up deflate compression");
-#if (PNG_LIBPNG_VER > 99)
   if (logging)
     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                           "    Compression buffer size: 32768");
   png_set_compression_buffer_size(ping,32768L);
-#endif
   if (logging)
     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                           "    Compression mem level: 9");
@@ -6996,6 +7357,7 @@ static unsigned int WriteOnePNGImage(Mng
         (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                               "    Compression strategy: Z_HUFFMAN_ONLY");
       png_set_compression_strategy(ping, Z_HUFFMAN_ONLY);
+      png_set_compression_level(ping,2);
     }
   if (logging)
     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
@@ -7008,7 +7370,7 @@ static unsigned int WriteOnePNGImage(Mng
       if (logging)
         (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                               "    Filter_type: PNG_INTRAPIXEL_DIFFERENCING");
-      ping_info->filter_type=PNG_INTRAPIXEL_DIFFERENCING;
+      ping_filter_method=PNG_INTRAPIXEL_DIFFERENCING;
     }
   else
     if (logging)
@@ -7025,8 +7387,8 @@ static unsigned int WriteOnePNGImage(Mng
       if ((image_info->quality % 10) != 5)
         base_filter=(int) image_info->quality % 10;
       else
-        if ((ping_info->color_type == PNG_COLOR_TYPE_GRAY) ||
-            (ping_info->color_type == PNG_COLOR_TYPE_PALETTE) ||
+        if ((ping_colortype == PNG_COLOR_TYPE_GRAY) ||
+            (ping_colortype == PNG_COLOR_TYPE_PALETTE) ||
             (image_info->quality < 50))
           base_filter=PNG_NO_FILTERS;
         else
@@ -7042,6 +7404,155 @@ static unsigned int WriteOnePNGImage(Mng
       }
     png_set_filter(ping,PNG_FILTER_TYPE_BASE,base_filter);
   }
+
+  ping_interlace_method=(image_info->interlace == LineInterlace);
+
+  if (mng_info->write_mng)
+    png_set_sig_bytes(ping,8);
+
+  if (logging)
+    (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                          "  Writing PNG header chunks");
+
+  png_set_IHDR(ping,ping_info,
+               ping_width,
+               ping_height,
+               ping_bit_depth,
+               ping_colortype,
+               ping_interlace_method,
+               ping_compression_method,
+               ping_filter_method);
+
+  if (ping_colortype == 3 && ping_valid_trns != 0)
+     {
+        if (logging)
+           (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+              "  Setting up tRNS chunk");
+        (void) png_set_tRNS(ping, ping_info,
+                           ping_trans_alpha,
+                           ping_num_trans,
+                           &ping_trans_color);
+     }
+
+  MagickFreeMemory(ping_trans_alpha);
+
+  if (image_matte && (!mng_info->adjoin || !mng_info->equal_backgrounds))
+    {
+      if (logging)
+         (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+              "  Setting up bKGD chunk");
+      if (ping_bit_depth < 8 && ping_colortype == PNG_COLOR_TYPE_GRAY)
+        {
+          png_uint_16
+            maxval;
+
+          png_color_16
+            background;
+
+          maxval=(1U << ping_bit_depth)-1;
+
+
+          background.gray=(png_uint_16)
+            (maxval*(PixelIntensity(&image->background_color))/MaxRGB);
+
+          png_set_bKGD(ping,ping_info,&background);
+        }
+
+      else
+        {
+          png_color_16
+            background;
+
+          if (image_depth < QuantumDepth)
+            {
+              int
+                maxval;
+
+              maxval=(1U << image_depth)-1;
+              background.red=(png_uint_16)
+                (maxval*image->background_color.red/MaxRGB);
+              background.green=(png_uint_16)
+                (maxval*image->background_color.green/MaxRGB);
+              background.blue=(png_uint_16)
+                (maxval*image->background_color.blue/MaxRGB);
+              background.gray=(png_uint_16)
+                (maxval*PixelIntensity(&image->background_color)/MaxRGB);
+            }
+          else
+            {
+              background.red=image->background_color.red;
+              background.green=image->background_color.green;
+              background.blue=image->background_color.blue;
+              background.gray=
+                (png_uint_16) PixelIntensity(&image->background_color);
+            }
+          background.index=(png_byte) background.gray;
+          png_set_bKGD(ping,ping_info,&background);
+        }
+    }
+
+#if defined(PNG_pHYs_SUPPORTED)
+  if ((image->x_resolution != 0) && (image->y_resolution != 0) &&
+      (!mng_info->write_mng || !mng_info->equal_physs))
+    {
+      int
+        unit_type;
+
+      png_uint_32
+        x_resolution,
+        y_resolution;
+
+      if (image->units == PixelsPerInchResolution)
+        {
+          unit_type=PNG_RESOLUTION_METER;
+          x_resolution=(png_uint_32) ((100.0*image->x_resolution+0.5)/2.54);
+          y_resolution=(png_uint_32) ((100.0*image->y_resolution+0.5)/2.54);
+        }
+      else if (image->units == PixelsPerCentimeterResolution)
+        {
+          unit_type=PNG_RESOLUTION_METER;
+          x_resolution=(png_uint_32) (100.0*image->x_resolution+0.5);
+          y_resolution=(png_uint_32) (100.0*image->y_resolution+0.5);
+        }
+      else
+        {
+          unit_type=PNG_RESOLUTION_UNKNOWN;
+          x_resolution=(png_uint_32) image->x_resolution;
+          y_resolution=(png_uint_32) image->y_resolution;
+        }
+
+      png_set_pHYs(ping,ping_info,x_resolution,y_resolution,unit_type);
+
+      if (logging)
+      {
+        (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+             "    Setting up pHYs chunk");
+        (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+             "      x_resolution=%lu",(unsigned long) x_resolution);
+        (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+             "      y_resolution=%lu",(unsigned long) y_resolution);
+        (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+             "      unit_type=%lu",(unsigned long) unit_type);
+      }
+    }
+#endif
+
+#if defined(PNG_oFFs_SUPPORTED)
+  if (mng_info->write_mng == 0 && (image->page.x || image->page.y))
+    {
+      if (!((image->page.width != 0 && image->page.width != image->columns) ||
+          (image->page.height != 0 && image->page.height != image->rows)))
+        {
+          png_set_oFFs(ping,ping_info,(png_int_32) image->page.x,
+                   (png_int_32) image->page.y, 0);
+          if (logging)
+            (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                              "    Setting up oFFs chunk");
+        }
+      /* else write caNv instead, later */
+    }
+#endif
+
   {
     ImageProfileIterator
       *profile_iterator;
@@ -7063,20 +7574,28 @@ static unsigned int WriteOnePNGImage(Mng
           {
             if (LocaleCompare(profile_name,"ICM") == 0)
               {
-#if (PNG_LIBPNG_VER > 10008) && defined(PNG_WRITE_iCCP_SUPPORTED)
+#if defined(PNG_WRITE_iCCP_SUPPORTED)
                 {
                   if (logging)
                     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                                           "  Setting up iCCP chunk");
+
                   png_set_iCCP(ping,ping_info,(png_charp) "icm",
-                               (int) 0, (png_charp) profile_info,
+                               (int) 0,
+#if (PNG_LIBPNG_VER < 10500)
+                               (png_charp) profile_info,
+#else
+                               (png_const_bytep) profile_info,
+#endif
+
                                (png_uint_32) profile_length);
                 }
 #else
                 {
                   if (logging)
                     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                          "  Setting up text chunk with iCCP Profile");
+                                          "  Setting up text chunk with"
+                                          " iCCP Profile");
                   png_write_raw_profile(image_info,ping,ping_info,
                                         "icm",
                                         "ICC Profile",
@@ -7089,18 +7608,23 @@ static unsigned int WriteOnePNGImage(Mng
               {
                 if (logging)
                   (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                        "  Setting up text chunk with iPTC Profile");
+                                        "  Setting up text chunk with"
+                                        " iPTC Profile");
                 png_write_raw_profile(image_info,ping,ping_info,
                                       "iptc",
                                       "IPTC profile",
                                       profile_info,
                                       (png_uint_32) profile_length);
               }
+            else if (LocaleCompare(profile_name,"exif") == 0)
+              /* Do not write exif; we'll write it later as eXIf */
+              ;
             else
               {
                 if (logging)
                   (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                        "  Setting up text chunk with %s profile",
+                                        "  Setting up text chunk with"
+                                        " %s profile",
                                         profile_name);
                 png_write_raw_profile(image_info,ping,ping_info,
                                       profile_name,
@@ -7131,8 +7655,8 @@ static unsigned int WriteOnePNGImage(Mng
         (void) png_set_sRGB(ping,ping_info,PerceptualIntent);
       png_set_gAMA(ping,ping_info,0.45455);
     }
-  not_valid=(!ping_info->valid);
-  if ((!mng_info->write_mng) || not_valid & PNG_INFO_sRGB)
+  if ((!mng_info->write_mng) ||
+       !png_get_valid(ping, ping_info, PNG_INFO_sRGB))
 #endif
     {
       if (!mng_info->have_write_global_gama && (image->gamma != 0.0))
